<?php 
function destroy_cache(){
	$cache=dirname(__FILE__)."/cache/";
	$d = dir($cache);
	while(false !== ($entry = $d->read())) {
		if(is_file($cache.$entry) && $entry!="index.html"){
			unlink($cache.$entry);					
		}
	}
	$d->close();
}

$city=get_option('wp_weather_city');
$cityname=get_option('wp_weather_city_name');

if(!@preg_match("/{/i",$city) && $city!=""){
	$city=explode("||",$city);
	$cityname=explode("||",$cityname);
	$new=array();
	$x=0;
	foreach($city as $a){
		$new[$a]=$cityname[$x];
		$x++;
	}
	$city=serialize($new);
	update_option('wp_weather_city',$city);
	delete_option("wp_weather_city_name");
}
if($city!="") $city=unserialize($city);

if(isset($_GET['delete'])){
	unset($city[$_GET['delete']]);
	update_option('wp_weather_city',serialize($city));
}

if(isset($_POST['city']) && $_POST['city']!=""){
	if(is_array($city)){
		destroy_cache();
		$city[$_POST['city']]=$_POST['city-'.$_POST['city']];
		update_option('wp_weather_city',serialize($city));
	}
	if($city=="" && get_option('wp_weather_city_temp')){
		$city[$_POST['city']]=$_POST['city-'.$_POST['city']];
		update_option('wp_weather_city',serialize($city));
	}else{		
		destroy_cache();
		$city[$_POST['city']]=$_POST['city-'.$_POST['city']];
		add_option('wp_weather_city',serialize($city),'myweather city');
		add_option('wp_weather_city_temp',"C",'myweather city temp');
		add_option('wp_weather_city_cache',"3600",'myweather city cache');
		add_option('wp_weather_template',"default",'myweather city template');
	}
}
if(isset($_POST['temp']) && $_POST['temp']!=""){
	if(get_option('wp_weather_city_temp')){
		destroy_cache();
		update_option('wp_weather_city_temp',$_POST['temp']);
		update_option('wp_weather_city_cache',$_POST['cache']);
		update_option('wp_weather_template',$_POST['template']);
	}else{
		destroy_cache();
		add_option('wp_weather_city_temp',$_POST['temp'],'myweather city temp');
		add_option('wp_weather_city_cache',$_POST['cache'],'myweather city cache');
		add_option('wp_weather_template',$_POST['template'],'myweather city template');
	}
}

$city=get_option('wp_weather_city');
if($city!="") $city=@unserialize($city);

$citytemp=get_option('wp_weather_city_temp');
$template=get_option('wp_weather_template');

if(!$citytemp){
	$citytemp="C";
}
if(!$template){
	$template="default";
}
$citycache=get_option('wp_weather_city_cache');
if(!$citycache){
	$citycache="3600";
}
?>
<div class="wrap">
	<h2>myWeather</h2>
	<?php if(is_array($city)){?>
	<table width="100%">
	<tr>
	<td width="50%" valign="top">
	<form action="plugins.php?page=myweather.php" method="post">		
			<h3>myWeather Configuration</h3>
		<table class="form-table"> 
			<tr valign="top"> 
				<th scope="row">Grade</th>
                <td><select name="temp">
                <option value="C"<?php if($citytemp=="C"){echo ' selected="selected"';}?>>Celsius</option>
                <option value="F"<?php if($citytemp=="F"){echo ' selected="selected"';}?>>Fahrenheit</option>
                </select></td>                      
			</tr>
			<tr valign="top"> 
				<th scope="row">Cache time</th>
                <td><input type="text" name="cache" size="6" value="<?php echo $citycache;?>" />seconds</td>                      
			</tr>
			<tr valign="top"> 
				<th scope="row">Cache dir</th>
                <td><?php
                if(is_writable(dirname(__FILE__)."/cache/")){
                	echo "writable";	
                }else{
                	echo "<strong style=\"color:red;\">not writable</strong>";	
                }
                ?></td>                      
			</tr>
			<tr valign="top"> 
				<th scope="row">Template</th>
                <td>
                <select name="template">
                <?php
                $d = dir(dirname(__FILE__)."/templates");
				while($entry=$d->read()) {
					if($entry!="." && $entry!=".."){
						if($entry == $template){
							echo '<option value="'.$entry.'" selected="selected">'.$entry."</option>\n";
						}else{
							echo '<option value="'.$entry.'">'.$entry."</option>\n";
						}
						
					}
				}
				$d->close();
                ?>
                </select></td>                      
			</tr>
		</table>
		<div class="submit"><input type="submit" name="Submit" value="Update Config &raquo;" /></div>

	</form>
	</td>
	<td width='50%' valign="top">
			<h3>Actual Cities</h3>
			<?php if(is_array($city)){?>
			<table class="form-table"> 
			<?php foreach($city as $code => $cityname){?>
			<tr valign="top"> 
				<th scope="row"><?php echo $cityname?></th>
                <td><a href="?page=myweather.php&delete=<?php echo $code?>">remove</a></td>                      
			</tr>
			<?php }?>
			</table>

			<?php }?>
	</td>
	</tr>
	</table>
	
	<?php }?>
	
	<form action="plugins.php?page=myweather.php#search" method="post">		
			<h3>Search city</h3>
		<table class="form-table"> 
			<tr valign="top"> 
				<th scope="row">Insert city name</th>
                <td><input type="text" name="code" value="<?php echo $_POST['code']?>" /></td>                     
			</tr>
		</table>
		<div class="submit"><input type="submit" name="Submit" value="Search city &raquo;" /></div>
	</form>

<?php


if(isset($_POST['code']) && $_POST['code']!=""){

	require_once(dirname(__FILE__).'/minixml/minixml.inc.php');

	$fdata = "http://xoap.weather.com/search/search?where=".urlencode($_POST['code']);

	
	$file=get_xml($fdata);
		
	$xmlObj = new MiniXMLDoc();
	$xmlObj->fromString($file);
	$xml = $xmlObj->getRoot();
	
	$value=$xml->getElement('search');
	$nn=0;
	if(is_object($value)){
		$partListChildren = $value->getAllChildren();
		$nn=count($partListChildren);
	}
	if($nn==0){
		echo "<h3>no city found</h3>";
	}else{
	$cityname= array();
	?>
	<form action="plugins.php?page=myweather.php" method="post">
	<h3><a name="search"></a>Search Result</h3>
		<table class="form-table"> 
			<tr valign="top"> 
<th scope="row">City Found</th>
<td>
<select name="city">
<?php foreach($partListChildren as $city){?>
<option value="<?php echo $city->attribute('id')?>"><?php echo $city->getValue();?></option>
<?php }?>
</select>
<?php foreach($partListChildren as $city){?>
<input type="hidden" name="city-<?php  echo $city->attribute('id')?>" value="<?php echo $city->getValue();?>" />
<?php }?>
</td>
</tr>
</table>
<div class="submit"><input type="submit" name="Submit" value="Save city &raquo;" /></div>
</form>
<?php 
	}
}
?>
		</div>
